# OAUTH2

## Configuration (Keycloak)

-   Base Config:
    -   Create Client
        -   (OpenID Connect)
        -   Client ID: set the same as in .env: OAUTH_CLIENT_ID
        -   Name: Think of something fitting
    -   Capability
        -   Client Authentication On
        -   Authorization Off
        -   Standard flow On
        -   Switch Off Direct access grants
        -   Rest stays Off
    -   URL-Settings (switch for the correct domain, example is for dev-setup)
        -   Root URL: `http://localhost:8080`
        -   Home URL: `/`
        -   Valid redirect URLs: `/redirect_target/*`
    -   Login Settings
        -   Login theme: `Keycloak`
        -   Consent required: On
        -   Display client on screen: On
        -   Client consent screen text: `AUTHENTICATE THE MATHEZIRKEL APP`
    -   Logout Settings
        -   Front channel logout: On
        -   Rest: May be empty
-   Roles:
    -   Roles to create for the client:
        -   `readparticipant`: To read all stuff that is associated to participants
        -   `writeparticipant`: To write all stuff that is associated to participants
        -   `export`: Get full export lists of participant data and write to cloud
        -   `writeevents`: API-ONLY Higher Level of auth to modify underlying Data-Structure
        -   `deleterecords`: API-ONLY access to manually delete stuff from the database (may destroy needed data, ! side effects)
        -   `readinstructor`: To read all stuff that is associated to instructors
        -   `writeinstructor`: To write all stuff that is associated to instructors
        -   `managesignup`: To manage signing up to events
        -   `managezirkelplan`: To manage the Zirkel Plan entries
    -   Set Roles for Users:
        -   To set roles for a user, go to `Users`->`User Details` (Click on User)->`Role Mapping`->`Assign Role`
        -   Roles will NOT be shown now, unless you change "Filter by realm roles" to "Filter by clients" (now if wanted, can filter name with the name of the Oauth-Client)
-   User-Info output !! IMPORTANT !!
    -   As our login-check always contacts the server at the `userinfo` endpoint, it is necessary that the roles are properly packed into the endpoint and the token
    -   Nothing will work if this is not configured properly, but it is easily missed
    -   Getting to the setup is really not trivial:
        -   `Clients`
        -   `Client-Details` (click on the client)
        -   `Client-Scopes`
        -   `##OAUTH_CLIENT_ID##-dedicated` (in the LIST, click on the NAME of the probably top-most item)
        -   Should arrive at `Dedicated Scopes`
    -   Add mapper:
        -   `By configuration`
        -   `User Client Role`
            -   Mapper Type: `User Client Role`
            -   Name: `client roles`
            -   clientID: ##OAUTH_CLIENT_ID##
            -   Multivalued: On
            -   Token Claim Name: `roles` (This is probably set wrong per default, weird Keycloak behavior: https://stackoverflow.com/a/64748129)
            -   Claim JSON Type: `String`
            -   Add to ID token: On
            -   Add to access token: On
            -   Add to userinfo: On
-   The client Secret that is generated by Keycloak under the following path needs to be set in the OAUTH_CLIENT_SECRET environment variable
    -   `Clients`
    -   `Client-Details` (click on the client)
    -   `Credentials`
    -   `Client Secret`

### Request userinfo from server (curl)

```cmd
curl $CURL_OPTS \
      -X POST \
      -H "Content-Type: application/x-www-form-urlencoded" \
      -d "access_token=TOKENHERE" \
    "https://auth.mathezirkel-augsburg.de/realms/dev/protocol/openid-connect/userinfo"
```

### Urls:

Configuration info is presented at this location: [https://auth.mathezirkel-augsburg.de/realms/dev/.well-known/openid-configuration](https://auth.mathezirkel-augsburg.de/realms/dev/.well-known/openid-configuration).

The url-values ned to be set in the .env file in production.

### Token Lifetime configuration

https://auth.mathezirkel-augsburg.de/admin/dev/console/#/dev/realm-settings/sessions

## Authentication flow (How does auth work in this application)

The authentication flow is NOT just the default [Authorization Code Grant](https://datatracker.ietf.org/doc/html/rfc6749#section-4.1).

(This would be the right choice if a server-side application `A` with a controlled web-based GUI wanted access to some data on a resource service `R`.
For this, `A` would perform OAUTH2(Authorization Code Grant) with the authorization server of `R` (`A-R`).
`A-R` would after the successful process give `A` a token, that `A` could send to `R` along with the request for the resource.
`R` checks with `A-R` if the token is valid and if it is, it gives back the resource.
In this example looking at [The Authorization Code Grant RFC graphic](https://datatracker.ietf.org/doc/html/rfc6749#section-4.1), the `client` is `A` (a server-side application), the `user-agent` is the browser of the user, the `Resource Owner` is the user that holds the password to `A-R` which is the authorization server.

HOWEVER if we look [here](https://datatracker.ietf.org/doc/html/rfc6749#section-2.1), we see that our tauri-client is a **public-type-client**.

But the first paragraph of the [Authorization Code Grant](https://datatracker.ietf.org/doc/html/rfc6749#section-4.1) tells us, that it is only suited for **confidential-type-clients** (tauri-app is not) and needs to receive incoming requests (oftentimes complicated because OAUTH2 Servers often do not like redirecting to localhost or so-called deep-urls)).

The fix for public clients is through the so-called Proof Key for Code Exchange mechanism [PKCE](https://datatracker.ietf.org/doc/html/rfc7636) to deal with the fact, that a malicious app could extract the **client_secret** of a **public-type-client** and redeem the Authz Code instead of out application.
But I do not like this and it seems really complicated to implement and more of a fix, than a solution.
Also it still has the redirection problems to the native app and even worse require implementing webserver stuff into the tauri-app (do not wanna do that).

Therefore this implements a quasi-version of PKCE with one additional party:

The public tauri client `T` generates a cryptographically random token.
The token then is hashed with sha256. The hash is shown to the user on the `T` and the user is asked to compare it.
`T` then asks the graphql backend server `S` to authenticate and sends the hash along with this request.
The `S` keeps the hash in memory along with a timestamp for one minute. It also shows the user the hash, in order to make sure he only proceeds to authenticate the application he desired.
(Otherwise any random app could trigger this chain and we wouldn't know which app we are currently authenticating).
The `S` is a **confidential-type-client**, so it can perform regular OAUTH2 [Authorization Code Grant](https://datatracker.ietf.org/doc/html/rfc6749#section-4.1) with the Keycloak authorization server `A-S`.
Because good measure these two also do PKCE for them self for good measure.

`S` now holds a token to authenticate **itself** against the `A-S`. But the token is linked to the hash and the timestamp.
If and client `T` now wants to get the token from the `S`, it needs to send the non-hashed token from the beginning.
`S` will hash, compare and then answer with the token to `T` if it matches.
`S` will delete everything after the minute expired or one client has successfully requested the token.

Now in the end, `T` holds the token, it can present to `S`, which can use `A-S` to verify it and give the data to `T`.
And at no point, we need to redirect to `T` because redirecting to `T` sucks and it is enough that `S` can speak https, which is also convenient for us.
